设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 55|回复: 4

[源码] 多线段加删点LWPOLYLINE/POLYLINE二合一

[复制链接]
发表于 6 天前 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
;多线段加删点,LWPOLYLINE/POLYLINE二合一了
;en图元名,index顶点索引,pt点
;当pt为点表,相应点索引位置插入pt
;当pt点为nil,删除索引点(起点索引0)
(defun ContinuePoly (en index pt / obj pts nn)
        (setq obj (vlax-ename->vla-object en))
    (setq pts (vla-get-Coordinates obj))
    (setq pts (vlax-safearray->list (vlax-variant-value pts)))
    (if (= (cdr(assoc 0(entget en))) "LWPOLYLINE")
            (setq nn 2) (setq nn 3)
    )
    (if(= (type pt) 'list)
            (progn
                    (if(= nn 3)(setq pts (nth-list  0.0 (* nn index) pts)))
                        (setq pts (nth-list  (cadr pt) (* nn index) pts))
                    (setq pts (nth-list  (car pt) (* nn index) pts))
            )
            (repeat        nn(setq pts (nth-list nil (* nn index) pts)))
    )
        (vlax-put obj 'coordinates pts);设置坐标      
)
;;表n位插入v或删除n位元素
(defun nth-list (v n lst / i l1 l2)
        (setq l1 lst l2 (reverse lst))
        (if v(setq v (list v)i n)(setq i (1+ n)))
        (repeat i (setq l1(cdr l1)))
        (repeat (- (length lst) n) (setq l2 (cdr l2)))
        (append (reverse l2) (append v l1))
)

--------------------------------------------------------------
功能示例
(setq en (entsel "选择LWPOLYLINE,POLYLINE多线段")  e (car en))
(setq index(fix (vlax-curve-getparamatpoint e
                     (vlax-curve-getclosestpointto e (cadr en)))));所击子段
(setq numpt (if (vlax-curve-isClosed e)(fix (vlax-curve-getendParam e))
                         (1+ (fix (vlax-curve-getendParam e)))));顶点数量
(ContinuePoly e numpt (getpoint "\n请输入添加的点:"));末尾加点
(ContinuePoly e numpt nil);末尾删点                        
(ContinuePoly e (1+ index) (getpoint "\n请输入添加的点:"));所击子段加点
(ContinuePoly e 1 (getpoint "\n请输入添加的点:"));第1子段加点
(ContinuePoly e 0 nil);删除起点
(ContinuePoly e 0 (getpoint "\n请输入添加的点:"));起点加点
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 168个

财富等级: 日进斗金

发表于 5 天前 | 显示全部楼层
谢谢分享!!!!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 7个

财富等级: 恭喜发财

发表于 4 天前 | 显示全部楼层
感谢分享!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 168个

财富等级: 日进斗金

发表于 4 天前 | 显示全部楼层
谢谢分享!!!!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

已领礼包: 7个

财富等级: 恭喜发财

发表于 10 小时前 | 显示全部楼层
感谢分享!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-10-23 18:30 , Processed in 0.109500 second(s), 30 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表